package org.rsg.carnivore.ilan;

import java.net.*;
import java.util.*;


//the Internet address might be interpreted as:
//
//    <network-number><subnet-number><host-number>
//
//                     1                   2                   3
// 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1
//+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
//|1 0|        NETWORK            |  SUBNET   |    Host Number    |
//+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

//the address zero is to be interpreted as meaning "this", as in "this network".  		0.0.0.0
//The address of all ones are to be interpreted as meaning "all", as in "all hosts".  	255.255.255.255
//For example, the address 128.9.255.255 could be interpreted as meaning all hosts on
//the network 128.9.  Or, the address 0.0.0.37 could be interpreted as meaning host 37 
//on this network.



//Class 	Prefix 		Default Mask
//Class A 	  1..127 	255.0.0.0
//Class B 	128..191 	255.255.0.0
//Class C 	192..223 	255.255.255.0


//128.122.x.0-255
//
//128.122.?.0-255

//NYU:		inet 128.122.227.120
//			Class B					255.255.0.0		(11111111.11111111.00000000.00000000)
//			netmask 0xfffffe00		255.255.254.0	(xxxxxxxx.xxxxxxxx.11111110.00000000) -- same as writing 128.122.227.120/23 (i.e. 23 one bits)
//																	   7 bits for subnets
//																	   9 bits for host addresses on this LAN
//			broadcast 128.122.227.255

//Eyebeam:	inet 172.16.2.141
//			Class C					255.255.255.0	(11111111.11111111.11111111.00000000)
//			netmask 0xffffff00		255.255.255.0	(xxxxxxxx.xxxxxxxx.xxxxxxxx.00000000) -- same as writing 172.16.2.141/24 (i.e. 24 one bits)
//																				0 bits for subnets
//																				8 bits for host addresses on this LAN
//			broadcast 172.16.2.255

public class Localhost {
	ArrayList<String> hostlist = new ArrayList<String>();
	Localhost() {
       findLocalhostNames();
	}

	void findLocalhostNames(){
	  try {
			NetworkInterface iface = null;
			for(Enumeration<NetworkInterface> ifaces = NetworkInterface.getNetworkInterfaces();ifaces.hasMoreElements();){
				iface = (NetworkInterface)ifaces.nextElement();
				System.out.println("Interface:"+ iface.getDisplayName());
				InetAddress ia = null;
				for(Enumeration<InetAddress> ips = iface.getInetAddresses(); ips.hasMoreElements(); ){
					ia = (InetAddress)ips.nextElement();
                    hostlist.add(ia.getCanonicalHostName()+"");
                    hostlist.add(ia.getHostAddress()+"");
					System.out.println(ia.getCanonicalHostName()+" "+ia.getHostAddress());
				}
			}
	  } catch (java.net.SocketException e) {}
	}
	
    public boolean isLocal(String ip, String host){
       for(int i=0; i<hostlist.size(); i++) {
         if((ip.equals(hostlist.get(i))) || (ip.equals(hostlist.get(i)))) { return true; }
       }
       return false;
     }

	public String toString() {
		return hostlist.toString();
	}
}