package org.rsg.carnivore.ilan;

import java.util.ArrayList;
import java.util.Collections;
import java.util.Comparator;

public class NodeFactory {
	public static void sortNodesByIsometricDepth(ArrayList<Node> nodes) {
	    Collections.sort(nodes, new ComparatorNodesByIsometricDepth());	  
//	    System.out.println("[NodeFactory] sortNodesByIsometricDepth");
	}
	
	public static boolean isProbablyAPrinter(int port) {
		switch(port) {
		//these are from `grep -i print etcservices_base.txt` 
		case 35:
		case 92:
		case 170:
		case 515:
		case 631:
		case 1045:
		case 1314:
		case 1392:
		case 2081:
		case 2291:
		case 3096:
		case 3396:
		case 3800:
		case 3910:
		case 3911:
		case 5309:
		case 8033:
		case 8100:
		case 9100:
			return true;
		default: 
			return false;
		}
	}

}

class ComparatorNodesByIsometricDepth implements Comparator<Node> {
	  public int compare(Node node1, Node node2) {		  
		  if(node1.getY()==node2.getY()) return 0;
		  return (node1.getY() < node2.getY()) ? 1 : -1 ;
	  }    
}