package org.rsg.carnivore.net;

import java.util.HashMap;
import org.rsg.carnivore.ilan.CarnivoreILanPApplet;

public class MacAddressLookup {
	public static final String DATABASE_FILE = "data/macaddresses.txt";
	public HashMap<String, String> database = new HashMap<String, String>(); 

	public static void main (String[] args) {		
		String query = "001b63";
//		String query = "00:1b:63:9f:c2:78";
		String result = MacAddressLookup.instance().query(query);
		System.out.println(query + " = " + result);
	}
	
	//singleton pattern
	public static MacAddressLookup instance() { return INSTANCE; }
	private static final MacAddressLookup INSTANCE = new MacAddressLookup();
	private MacAddressLookup() {
		System.out.println("[MacAddressLookup] Loading database");  
		loadDatabase();
//		System.out.println("OK");
	}

	public String query(String query) {
		if(isTooLong(query)) 
			query = stripQuery(query);
		
		if(database.containsKey(query.toUpperCase())) return database.get(query.toUpperCase());
		return "";
	}
	
	public final static int MAX_LENGTH = 6; 
	boolean isTooLong(String query) {
		return query.length() > MAX_LENGTH;
	}
	
	String stripQuery(String query) {
//		System.out.print("stripQuery("+query+")... ");
		query = query.replaceAll(":", ""); 
		if(isTooLong(query)) 
			query = query.substring(0, MAX_LENGTH);
//		System.out.println(query);
		return query;
	}
		
	   private void loadDatabase() {
//			String[] lines = PApplet.loadStrings(new File(databaseFile));  
//   private void loadDatabase() {
//		String[] lines = CarnivoreILanPApplet.loadStrings(new File(DATABASE_FILE));  
		   String[] lines = CarnivoreILanPApplet.stringsMACAddresses;

		if(null==lines || lines.length==0) return;

		for(String line : lines) {
        	String[] s = line.split(" ", 2); 
        	database.put(s[0], s[1]);
        }
  }
   
  public String toString() {
	  return "(MacAddressLookup) " + database.size() + " mac addresses on file";
  }
} 