package org.rsg.lib.chrome.button;

import java.awt.Rectangle;

import org.rsg.lib.chrome.Chrome;
import org.rsg.lib.chrome.ChromeDispatcher;

import processing.core.PApplet;

public class Kill extends AbstractButton {
	private static final long serialVersionUID = 1L;
	private String tooltip = "Quit";

	@Override
	public void draw(PApplet papplet) {
		super.draw(papplet);
		Rectangle r = bounds();		
		int spacer = 2;
		
		//draw an "X"
		papplet.stroke(Chrome.darkgray());
		papplet.line(r.x + spacer, 
				 	 r.y + spacer, 
				 	 r.x + r.width - spacer, 
				 	 r.y + r.height - spacer);

		papplet.line(r.x + r.width - spacer, 
			 	 	 r.y + spacer, 
			 	 	 r.x + spacer, 
			 	 	 r.y + r.height - spacer);

		drawBoundingBox(papplet);
	}

	@Override
	public Rectangle bounds() {
		int x = Chrome.getAPP_SIZE().width - SPACER_RIGHT - (SIZE.width + SPACER_BETWEEN)*1;
		return new Rectangle(x,y,w,h);
	}

	@Override
	public void click(PApplet papplet) {
		ChromeDispatcher.exit();
	}

	@Override
	public String getTooltip() { return tooltip; }
}
