package org.rsg.lib.chrome.button;

import java.awt.Rectangle;

import org.rsg.lib.chrome.Chrome;
import org.rsg.lib.chrome.ChromeDispatcher;

import processing.core.PApplet;

public class Maximize extends AbstractButton {
	private static final long serialVersionUID = 1L;
	private String tooltip = "Full screen";

	@Override
	public void draw(PApplet papplet) {
		super.draw(papplet);
		Rectangle r = bounds();		
		
		//short header white box
		papplet.fill(Chrome.white());
		papplet.noStroke();
		papplet.rect(r.x, r.y, r.width, CHROME_HEIGHT);		
		
		//grey line between white box and rest of button
		papplet.stroke(Chrome.darkgray());
		int spacer = 2;
		papplet.line(r.x + spacer, 
				 	 r.y + CHROME_HEIGHT, 
				 	 r.x + r.width - spacer, 
				 	 r.y + CHROME_HEIGHT);

		drawBoundingBox(papplet);
	}

	@Override
	public Rectangle bounds() {
		int x = Chrome.getAPP_SIZE().width - SPACER_RIGHT - (SIZE.width + SPACER_BETWEEN)*2;
		return new Rectangle(x,y,w,h);
	}

	@Override
	public void click(PApplet papplet) {
		ChromeDispatcher.fullscreenWindow();
	}

	@Override
	public String getTooltip() { return tooltip; }
}
