package org.rsg.lib.chrome.button;

import java.awt.Rectangle;

import org.rsg.lib.chrome.Chrome;
import org.rsg.lib.chrome.ChromeDispatcher;

import processing.core.PApplet;

public class Minimize extends AbstractButton {
	private static final long serialVersionUID = 1L;
	private String tooltip = "Minimize";

	@Override
	public void draw(PApplet papplet) {
		super.draw(papplet);		
		papplet.fill(Chrome.white());
		papplet.stroke(Chrome.black());
		Rectangle r = bounds();
		papplet.rect(r.x, r.y + r.height - CHROME_HEIGHT, r.width, CHROME_HEIGHT);		
	}

	@Override
	public Rectangle bounds() {
		int x = Chrome.getAPP_SIZE().width - SPACER_RIGHT - (SIZE.width + SPACER_BETWEEN)*2;
		return new Rectangle(x,y,w,h);
	}

	@Override
	public void click(PApplet papplet) {
		ChromeDispatcher.minimizeWindow();
	}

	@Override
	public String getTooltip() { return tooltip; }
}
