package org.rsg.lib.chrome.button;

import java.awt.Rectangle;

import org.rsg.lib.chrome.Chrome;

import processing.core.PApplet;

public class Resize extends AbstractButton {		
	private static final long serialVersionUID = 1L;
	private String tooltip = "Resize";

	@Override
	public void draw(PApplet papplet) {
		if(!Chrome.FULL_SCREEN) { //unlike other buttons, resize is never shown in fullscreen mode
			super.draw(papplet);
			Rectangle r = bounds();		
			int spacer = 3;
			
			papplet.pushMatrix();
			papplet.translate(r.x + r.width/2, r.y + r.height/2);
			papplet.rotate((float) (-Math.PI/4));
			
			//draw diagonal lines
			papplet.stroke(Chrome.darkgray());
			papplet.translate(0,-1);
			papplet.line(-r.width, 0, r.width, 0);			
			papplet.translate(0,spacer);
			papplet.line(-r.width, 0, r.width, 0);
			papplet.translate(0,spacer);
			papplet.line(-r.width, 0, r.width, 0);
			papplet.popMatrix();
		}
	}

	@Override
	public Rectangle bounds() {
		int w = SIZE.width;
		int h = SIZE.width;		
		int x = Chrome.getAPP_SIZE().width - w;
		int y = Chrome.getAPP_SIZE().height - h;
		return new Rectangle(x,y,w,h);
	}

	@Override
	public void click(PApplet papplet) {}	

	@Override
	public String getTooltip() { return tooltip; }
}
