package org.rsg.lib.net;

import java.net.NetworkInterface;
import java.net.SocketException;
import java.util.ArrayList;
import java.util.Enumeration;

public class NetworkInterfaces {
	private static ArrayList<NetworkInterface> _interfaces = null;
	private NetworkInterfaces() {}
	
	public static void main(String[] args) {
		ArrayList<NetworkInterface> interfaces = getInterfaces();
		System.out.print("[NetworkInterfaces] ");
		for(NetworkInterface i : interfaces) {
			System.out.print(i.getName() + " ");
		}
		System.out.println("");
	}	

	public static ArrayList<NetworkInterface> getInterfaces() {
		if(null == _interfaces) { initialize(); }
		return _interfaces;
	}
	
	private static void initialize() {
		_interfaces = new ArrayList<NetworkInterface>();
		NetworkInterface iface = null;
		try {
			for (Enumeration<NetworkInterface> ifaces = NetworkInterface.getNetworkInterfaces(); ifaces.hasMoreElements();) {
				iface = (NetworkInterface) ifaces.nextElement();
				_interfaces.add(iface);
			}
		} catch (SocketException e) {
			e.printStackTrace();
		}
	}
}
