package org.rsg.lib.polygon;

import java.awt.geom.Point2D;

public class Polygon {

	
	public static boolean isInside(Point2D.Float[] v, Point2D.Float t){
		    int count = 0;
		    Point2D.Float testOut;
		    for(int i = 0; i < v.length -1 ; i++){
		      testOut = lineSegIntersection(t.x, t.y, 
		    		  						0, t.y,  //draw left to zero 
		    		  						v[i].x, v[i].y, 
		    		  						v[i+1].x, v[i+1].y);
		      if(testOut != null){
		        count++;
		      }
		    }
		    
		    if(count % 2 != 0) //cuts the poly perimeter an *even* number of times, therefore we're outside
		       return false;
		    return true;
	 }

	 private static Point2D.Float lineSegIntersection(float x1, float y1, 
			 										  float x2, float y2, 
			 										  float x3, float y3, 
			 										  float x4, float y4) {
		    float bx = x2 - x1;
		    float by = y2 - y1;
		    float dx = x4 - x3;
		    float dy = y4 - y3;

		    float b_dot_d_perp = bx * dy - by * dx;

		    if(b_dot_d_perp == 0) return null;

		    float cx = x3 - x1;
		    float cy = y3 - y1;

		    float t = (cx * dy - cy * dx) / b_dot_d_perp;
		    if(t < 0 || t > 1) return null;

		    float u = (cx * by - cy * bx) / b_dot_d_perp;
		    if(u < 0 || u > 1) return null;

		    return new Point2D.Float(x1+t*bx, y1+t*by);
	}

}
